function varargout = CHIK_Model(varargin)
% CHIK_MODEL MATLAB code for CHIK_Model.fig
%      CHIK_MODEL, by itself, creates a new CHIK_MODEL or raises the existing
%      singleton*.
%
%      H = CHIK_MODEL returns the handle to a new CHIK_MODEL or the handle to
%      the existing singleton*.
%
%      CHIK_MODEL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CHIK_MODEL.M with the given input arguments.
%
%      CHIK_MODEL('Property','Value',...) creates a new CHIK_MODEL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before CHIK_Model_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to CHIK_Model_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help CHIK_Model

% Last Modified by GUIDE v2.5 29-Jun-2015 15:35:38

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @CHIK_Model_OpeningFcn, ...
    'gui_OutputFcn',  @CHIK_Model_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before CHIK_Model is made visible.
function CHIK_Model_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to CHIK_Model (see VARARGIN)
global A Countries
global Growth Cases Weeks W C
global Wid Thr Mxg L2 R2 Mxg2 Lw
global last_week
global MW

% Choose default command line output for CHIK_Model
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes CHIK_Model wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% Read data file
filename='CHIK_Model_Input.xlsx';
[A,txt,raw]=xlsread(filename);

% The first column of txt contains the countries, starting row 3
Countries=txt(3:end,1);
set(handles.popupmenu1,'String',...
    ['Country/Territories'; Countries])

% Remove repeated values in rows of A
W = zeros(size(A)); % W contains the weeks when data points are recorded
C = W;              % C contains the corresponding numbers of cases
% Define a more refined grid on which to interpolate the data
h=1/28;
Weeks=1:h:size(A,2);                    % Time in weeks
Cases=zeros(size(A,1),length(Weeks));   % Number of cases
Growth=zeros(size(A,1),length(Weeks));  % Growth rate

% Remove outliers
A(55,51)=A(55,50);
A(44,47:50)=A(44,46);
A(41,47:50)=A(41,46);

% Process input data
for i=1:size(A,1)
    B = A(i,:);
    We = 1:1:length(B);
    if sum(B) > 0
        % Remove repeated values except zeros
        D=[1 B(2:end)-B(1:end-1)];
        We(D==0 & B~=0 & B~=B(end))=[];
        B(D==0 & B~=0 & B~=B(end))=[];
        % Record raw data in W and C matrices
        W(i,1:length(We))=We;
        C(i,1:length(We))=B;
        % First smooth and then interporlate the data
        Cases(i,:)=interp1(We,smooth(We,B,6),Weeks,'pchip');
        % Growth rate
        Growth(i,:)=[(Cases(i,2)-Cases(i,1))/h ...
            (Cases(i,3:end)-Cases(i,1:end-2))/2/h ...
            (Cases(i,end)-Cases(i,end-1))/h];
    end
end

% Fill-in parameters
Wid=zeros(size(Countries));
Mxg=Wid; Thr=Wid;
L2=Wid; R2=L2; Mxg2=L2; Lw=L2;
fill_in_parameters;
MW=2*0.11735;

% Define duration of simulation
last_week=90;

set(gcf,'Name','CHIK Model')


% --- Outputs from this function are returned to the command line.
function varargout = CHIK_Model_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1
global Wid Mxg L2 R2 Mxg2 Lw

% Get country index
ci=get(hObject,'Value')-1;

% Set slider parameters and values
if ci == 0
    set(handles.Text_L2,'String',' ')
    set(handles.Text_R2,'String',' ')
    set(handles.Text_Mxg_2,'String',' ');
    set(handles.Text_Low,'String',' ');
    set(handles.Text_Wid_1,'String',' ')
    set(handles.Text_Mxg_1,'String',' ');
    axes(handles.axes1); cla;
    axes(handles.axes2); cla;
else
    if Wid(ci)~=0
        set(handles.Slider_Wid_1,'Min',Wid(ci)*.1);
        set(handles.Slider_Wid_1,'Max',Wid(ci)*20);
        set(handles.Slider_Wid_1,'Value',2*Wid(ci));
        set(handles.Text_Wid_1,'String',num2str(2*Wid(ci)));
        set(handles.Slider_Mxg_1,'Min',Mxg(ci)*.1);
        set(handles.Slider_Mxg_1,'Max',Mxg(ci)*10);
        set(handles.Slider_Mxg_1,'Value',Mxg(ci));
        set(handles.Text_Mxg_1,'String',num2str(Mxg(ci)));
    else
        set(handles.Text_Wid_1,'String',' ')
        set(handles.Text_Mxg_1,'String',' ');
    end
    if L2(ci)~=0
        set(handles.checkbox1,'Value',1);
        set(handles.Slider_L2,'Min',L2(ci)*.1);
        set(handles.Slider_L2,'Max',L2(ci)*10);
        set(handles.Slider_L2,'Value',L2(ci));
        set(handles.Text_L2,'String',num2str(L2(ci)));
        set(handles.Slider_R2,'Min',R2(ci)*.1);
        set(handles.Slider_R2,'Max',R2(ci)*10);
        set(handles.Slider_R2,'Value',R2(ci));
        set(handles.Text_R2,'String',num2str(R2(ci)));
        set(handles.Slider_Mxg_2,'Min',Mxg2(ci)*.1);
        set(handles.Slider_Mxg_2,'Max',Mxg2(ci)*10);
        set(handles.Slider_Mxg_2,'Value',Mxg2(ci));
        set(handles.Text_Mxg_2,'String',num2str(Mxg2(ci)));
        set(handles.Slider_Low,'Min',0);
        set(handles.Slider_Low,'Max',Mxg2(ci));
        set(handles.Slider_Low,'Value',Lw(ci));
        set(handles.Text_Low,'String',num2str(Lw(ci)));
    else
        set(handles.checkbox1,'Value',0);
        set(handles.Text_L2,'String',' ')
        set(handles.Text_R2,'String',' ')
        set(handles.Text_Mxg_2,'String',' ');
        set(handles.Text_Low,'String',' ');
    end
    
    % Run model and plot results
    run_and_plot(handles,ci)
end


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global A Countries
global Growth Cases Weeks W C
global Wid Thr Mxg L2 R2 Mxg2 Lw
global last_week

first_week=size(A,2)+1;
ic_excluded=find(Wid==0);
WP=zeros(length(Countries)+1,last_week);
WP(1,:)=1:1:last_week;
WP(2:end,1:first_week-1)=round(A);
for ci=1:1:length(Countries)
    if sum(ic_excluded==ci)==0
        [s,q]=Run_Model(handles,ci);
        WP(ci+1,first_week:last_week)=round(q(find(s==first_week,1):end));
    else
        WP(ci+1,first_week:last_week)=ones(1,last_week-first_week+1)*A(ci,end);
    end
end
filename='CHIK_Model_Output.xlsx';
xlswrite(filename,WP(:,first_week+1:last_week),1,'B2'); % forecast

Param=zeros(length(Countries),6);
Param(:,1)=2*Wid; Param(:,2)=Mxg;
Param(:,3)=L2; Param(:,4)=R2; Param(:,5)=Mxg2; Param(:,6)=Lw;
xlswrite(filename,Param,2,'B2'); % forecast parameters

% --- Executes on slider movement.
function Slider_Wid_1_Callback(hObject, eventdata, handles)
% hObject    handle to Slider_Wid_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global Wid Mxg Thr L2
global MW

ci=get(handles.popupmenu1,'Value')-1;
if ci ~= 0
    Wid(ci)=get(hObject,'Value')/2;
    set(handles.Text_Wid_1,'String',num2str(2*Wid(ci)));
    Thr(ci)=round(max(Wid(ci),L2(ci))./10);
    run_and_plot(handles,ci);
end

% --- Executes during object creation, after setting all properties.
function Slider_Wid_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Slider_Wid_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function Slider_Mxg_1_Callback(hObject, eventdata, handles)
% hObject    handle to Slider_Mxg_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global Mxg Wid Thr L2
global MW
ci=get(handles.popupmenu1,'Value')-1;
if ci ~= 0
    Mxg(ci)=get(hObject,'Value');
    set(handles.Text_Mxg_1,'String',num2str(Mxg(ci)));
    Thr(ci)=round(max(Wid(ci),L2(ci))./10);
    run_and_plot(handles,ci);
end

% --- Executes during object creation, after setting all properties.
function Slider_Mxg_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Slider_Mxg_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function Slider_L2_Callback(hObject, eventdata, handles)
% hObject    handle to Slider_L2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global L2

ci=get(handles.popupmenu1,'Value')-1;
if ci ~= 0
    L2(ci)=get(hObject,'Value');
    set(handles.Text_L2,'String',num2str(L2(ci)));
    run_and_plot(handles,ci);
end


% --- Executes during object creation, after setting all properties.
function Slider_L2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Slider_L2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function Slider_R2_Callback(hObject, eventdata, handles)
% hObject    handle to Slider_R2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global R2

ci=get(handles.popupmenu1,'Value')-1;
if ci ~= 0
    R2(ci)=get(hObject,'Value');
    set(handles.Text_R2,'String',num2str(R2(ci)));
    run_and_plot(handles,ci);
end

% --- Executes during object creation, after setting all properties.
function Slider_R2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Slider_R2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function Slider_Mxg_2_Callback(hObject, eventdata, handles)
% hObject    handle to Slider_Mxg_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global Mxg2

ci=get(handles.popupmenu1,'Value')-1;
if ci ~= 0
    Mxg2(ci)=get(hObject,'Value');
    set(handles.Text_Mxg_2,'String',num2str(Mxg2(ci)));
    run_and_plot(handles,ci);
end

% --- Executes during object creation, after setting all properties.
function Slider_Mxg_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Slider_Mxg_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function fill_in_parameters
global Wid Thr Mxg L2 R2 Mxg2 Lw

Wid(1)=18; Mxg(1)=5.3; L2(1)=35.5; R2(1)=300; Mxg2(1)=9; Lw(1)=0.2;
Wid(2)=740; Mxg(2)=90;
Wid(3)=400; Mxg(3)=20;
Wid(4)=800; Mxg(4)=58;
Wid(5)=50; Mxg(5)=16;
Wid(6)=975; Mxg(6)=200;
Wid(11)=6000; Mxg(11)=557;
Wid(12)=500; Mxg(12)=15;
Wid(13)=95; Mxg(13)=29; L2(13)=100; R2(13)=2400; Mxg2(13)=29; Lw(13)=1;
Wid(15)=170000; Mxg(15)=17500;
Wid(16)=1500; Mxg(16)=192;
Wid(17)=6; Mxg(17)=2.7; L2(17)=12.5; R2(17)=20; Mxg2(17)=1.1; Lw(17)=.4;
Wid(18)=1450; Mxg(18)=260;
Wid(19)=1880; Mxg(19)=260; L2(19)=2700; R2(19)=3850; Mxg2(19)=250; Lw(19)=0.1;
Wid(20)=275000; Mxg(20)=45000;
Wid(22)=69900; Mxg(22)=12269;
Wid(24)=5300; Mxg(24)=950; L2(24)=9000; R2(24)=16500; Mxg2(24)=850; Lw(24)=0.1;
Wid(25)=2000; Mxg(25)=187;
Wid(26)=40800; Mxg(26)=6100;
Wid(27)=80000; Mxg(27)=12138;
Wid(28)=3200; Mxg(28)=500;
Wid(29)=32500; Mxg(29)=9800;
Wid(30)=6000; Mxg(30)=1100;
Wid(31)=650; Mxg(31)=155; L2(31)=1200; R2(31)=1900; Mxg2(31)=115; Lw(31)=0.1;
Wid(32)=35000; Mxg(32)=3100; L2(32)=67500; R2(32)=80000; Mxg2(32)=2700; Lw(32)=1000;
Wid(33)=110; Mxg(33)=24;
Wid(34)=300; Mxg(34)=35;
Wid(35)=15000; Mxg(35)=1586;
Wid(36)=40; Mxg(36)=4.25;
Wid(38)=80; Mxg(38)=4;
Wid(39)=14000; Mxg(39)=1950;
Wid(41)=300; Mxg(41)=130; L2(41)=500; R2(41)=2250; Mxg2(41)=37; Lw(41)=9;
Wid(42)=230; Mxg(42)=30;
Wid(43)=1000; Mxg(43)=45.5;
Wid(44)=1900; Mxg(44)=750; L2(44)=4800; R2(44)=7500; Mxg2(44)=46; Lw(44)=46;
Wid(45)=230; Mxg(45)=60; L2(45)=475; R2(45)=1700; Mxg2(45)=180; Lw(45)=3;
Wid(47)=110; Mxg(47)=18; L2(47)=385; R2(47)=470; Mxg2(47)=16; Lw(47)=7.5; % Final
Wid(48)=615; Mxg(48)=150;
Wid(49)=67.5; Mxg(49)=16.2; L2(49)=53; R2(49)=320; Mxg2(49)=19; Lw(49)=8; % Final
Wid(50)=13; Mxg(50)=4.8;    % Final
Wid(51)=410; Mxg(51)=90; L2(51)=220; R2(51)=2500; Mxg2(51)=110; Lw(51)=0.1;
Wid(53)=46450; Mxg(53)=5400;
Wid(54)=1400; Mxg(54)=75;
Wid(55)=515; Mxg(55)=135; L2(55)=930; R2(55)=1620; Mxg2(55)=85; Lw(55)=40;

% Define threshold for initial condition
Thr=round(max(Wid,L2)./10);


% --- Executes on slider movement.
function Slider_Low_Callback(hObject, eventdata, handles)
% hObject    handle to Slider_Low (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
global Lw

ci=get(handles.popupmenu1,'Value')-1;
if ci ~= 0
    Lw(ci)=get(hObject,'Value');
    set(handles.Text_Low,'String',num2str(Lw(ci)));
    run_and_plot(handles,ci);
end

% --- Executes during object creation, after setting all properties.
function Slider_Low_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Slider_Low (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1
global Wid Mxg L2 R2 Mxg2 Lw

ci=get(handles.popupmenu1,'Value')-1;
if ci ~= 0
    if get(hObject,'Value') == 0
        set(handles.Text_L2,'String',' ')
        set(handles.Text_R2,'String',' ')
        set(handles.Text_Mxg_2,'String',' ');
        set(handles.Text_Low,'String',' ');
    else
        if L2(ci)~=0
            set(handles.Text_L2,'String',num2str(L2(ci)));
            set(handles.Text_R2,'String',num2str(R2(ci)));
            set(handles.Text_Mxg_2,'String',num2str(Mxg2(ci)));
            set(handles.Text_Low,'String',num2str(Lw(ci)));
        else
            L2(ci)=2*Wid(ci);
            set(handles.Slider_L2,'Value',L2(ci))
            set(handles.Text_L2,'String',num2str(L2(ci)))
            set(handles.Slider_L2,'Min',L2(ci)*.1);
            set(handles.Slider_L2,'Max',L2(ci)*20);
            R2(ci)=3*Wid(ci);
            set(handles.Slider_R2,'Value',R2(ci))
            set(handles.Text_R2,'String',num2str(R2(ci)))
            set(handles.Slider_R2,'Min',R2(ci)*1);
            set(handles.Slider_R2,'Max',R2(ci)*40);
            Mxg2(ci)=Mxg(ci);
            set(handles.Slider_Mxg_2,'Value',Mxg2(ci));
            set(handles.Text_Mxg_2,'String',num2str(Mxg2(ci)));
            set(handles.Slider_Mxg_2,'Min',Mxg2(ci)*.1);
            set(handles.Slider_Mxg_2,'Max',Mxg2(ci)*20);
            Lw(ci)=Mxg(ci)/40;
            set(handles.Slider_Low,'Value',Lw(ci));
            set(handles.Text_Low,'String',num2str(Lw(ci)));
            set(handles.Slider_Low,'Min',0);
            set(handles.Slider_Low,'Max',Mxg2(ci));
        end
    end
    run_and_plot(handles,ci);
end

function [s,q]=Run_Model(handles,ci)
global Cases Weeks
global Wid Thr Mxg L2 R2 Mxg2 Lw
global last_week

% ci = index of country
Z2=Cases(ci,:);

% Quadratic fit
r1=Mxg(ci);
r2=Wid(ci);

% Double quadratic fit
r3=Mxg2(ci);
r4=L2(ci);
r5=R2(ci);
r=Lw(ci);

% Integrate model ODE
i0=find(Z2>Thr(ci),1);   % index such that # of cases is larger than Thr(ci)
if isempty(i0)
    i0=find(Z2>max(Z2)/2,1);
end
t0=ceil(Weeks(i0));      % Initial time
on=get(handles.checkbox1,'Value');
[s,q]=ode45(@(t,y)grw(t,y,r1,r2,r3,r4,r5,r,on),t0:1:last_week,Z2(Weeks==t0));

function [x,ft]=plot_growth(handles,ci)
global Wid Mxg L2 R2 Mxg2 Lw

% Quadratic fit
r1=Mxg(ci);
r2=Wid(ci);
x=0:0.1:max(R2(ci),2*Wid(ci));
ft1=r1*(1-(x-r2).^2./r2.^2);

% Double quadratic fit
r3=Mxg2(ci);
r4=L2(ci);
r5=R2(ci);
r=Lw(ci);
if get(handles.checkbox1,'Value') == 1
    ft2=r3*(1-4/(r5-r4)^2*(x-(r4+r5)/2).^2);
else
    ft2=zeros(size(x));
end

% Growth model
if get(handles.checkbox1,'Value') == 0
    ft = ft1;
else
    ft=(x<(r4+r5)/2).*(x>r4/2).*...
        (max(ft1,ft2).*(max(ft1,ft2)>=r)+r*(max(ft1,ft2)<r))...
        + (x<(r4+r5)/2).*(x<=r4/2).*max(ft1,ft2) ...
        + (x>=(r4+r5)/2).*max(ft1,ft2);
end

function run_and_plot(handles,ci)
global Wid
global Growth Cases W C

% Run model
if Wid(ci)~=0
    [s,q]=Run_Model(handles,ci);
end

% Plot Growth rate & its approximation
Z1=Growth(ci,:);
Z2=Cases(ci,:);
axes(handles.axes1);
if Wid(ci)~=0
    plot(Z2,Z1)
    hold on
    [x,ft]=plot_growth(handles,ci);
    plot(x,ft,'r');
    xlim([0 ceil(max(x))])
    ylim([0 1.1*ceil(max(Z1))])
    hold off
else
    cla;
end
title('Growth Rate vs Cases')

axes(handles.axes2);
Z3=W(ci,:);
Z4=C(ci,:);
if Wid(ci)~=0
    plot(s,q,'r',Z3,Z4,'bo',s,q,'r*')
    xlim([0 ceil(max(s))])
else
    cla
end
title('Cases vs Weeks')

function dy=grw(t,y,r1,r2,r3,r4,r5,r,on)

ft1=r1*(1-(y-r2).^2./r2.^2);
if on ~=0
    ft2=r3*(1-4/(r5-r4)^2*(y-(r4+r5)/2).^2);
    dy=(y<(r4+r5)/2).*(y>r4/2).*...
        (max(ft1,ft2).*(max(ft1,ft2)>=r)+r*(max(ft1,ft2)<r))...
        + (y<(r4+r5)/2).*(y<=r4/2).*max(ft1,ft2) ...
        + (y>=(r4+r5)/2).*max(ft1,ft2);
else
    dy=ft1;
end
